<template>
    <div v-if="isChecked">
        <div v-if="!isAuth">
            <div>Вход</div>
            <form>
                <label>
                    <input
                        type="email"
                        v-model="loginData.email"
                        placeholder="Емейл"
                    /> </label
                ><br />
                <label>
                    <input
                        type="password"
                        v-model="loginData.password"
                        placeholder="Пароль"
                    /> </label
                ><br />

                <QuestBtn
                    type="submit"
                    :disabled="!isValid || loading"
                    @click.prevent="loginUser"
                >
                    Войти
                </QuestBtn>
                <br />
                <router-link :to="{ name: 'Register' }"
                    ><span class="text-gray-600">Регистрация</span></router-link
                >
            </form>
        </div>
        <QuestBtn v-else @click="logoutUser">
            {{ user.email }} ({{ roleName }}) Выйти
        </QuestBtn>
    </div>
</template>

<script>
import { mapActions, mapGetters, mapState } from "vuex";
import { textContent } from "@/utils/textContent";
import QuestBtn from "@/components/QuestBtn";
import snackbar from "@/utils/snackbar";

const initialLoginData = {
    email: process.env.VUE_APP_EMAIL || "",
    password: process.env.VUE_APP_PASSWORD || "",
};

export default {
    name: "Login",
    components: { QuestBtn },
    data: () => ({
        loginData: { ...initialLoginData },
        loading: false,
        isChecked: false,
    }),
    computed: {
        ...mapGetters("app", ["isAuth", "roles"]),
        ...mapState("app", ["token", "user"]),
        isValid() {
            const { email, password } = this.loginData;
            return email && password;
        },
        roleName() {
            return textContent.roles[this.user.roles[0].name];
        },
    },
    methods: {
        ...mapActions("app", ["login", "logout", "me"]),
        async loginUser() {
            try {
                this.loading = true;
                await this.login(this.loginData);
            } catch (e) {
                snackbar(e);
            } finally {
                this.loading = false;
            }
        },
        async logoutUser() {
            try {
                this.loading = true;
                if (this.$route.name !== "Welcome")
                    await this.$router.push({ name: "Welcome" });
                await this.logout();
            } catch (e) {
                snackbar(e);
            } finally {
                this.loading = false;
            }
        },
    },
    async beforeMount() {
        try {
            if (this.token && !this.user) await this.me();
        } catch (e) {
            snackbar(e);
            await this.$router.push({ name: "Welcome" });
            await this.logout();
        } finally {
            this.isChecked = true;
        }
    },
};
</script>

<style scoped></style>
